#define CM(JJ,tJ,tU) tU	  /* Heisenberg-,  t-J- or  Hubbard-model */
/* #ifndef NN            /* ermoeglicht    cc -DNN=5 ... -> problems -> NN */ 
/* #define NN        8   /* number of sites 2..4,8,10,16 */
/* #endif                /*   */
#define bipartit  0   /* Anzahl Plaetze und Parameter */
#define star      0   /* Anzahl Plaetze und Parameter */
#define KCuF      0   /* Anzahl Plaetze und Parameter */
#define LaBaCuO   0   /* Anzahl Plaetze und Parameter */

/* ================== Cu-Ligand-Kette ================================ */
#if defined(CuLiKette)  /* >=2 !!! */
#define NN 3*CuLiKette
#define Ne NN
#define Nw 4*CuLiKette
  int  io=1, nu=CuLiKette/2, nd=CuLiKette/2+CuLiKette%2, iw[Nw][2];
  cplx wj[Nw], wt[Nw], wu[NN], we[NN];
#if !defined(Sym) && CuLiKette==2
#define Sym 1  
  int  is[Sym][NN]={1,0,3,2,5,4}, 
       ws[Sym]={1};
#elif !defined(Sym) && CuLiKette==4
#define Sym 1  
  int  is[Sym][NN]={{2,3,0,1, 6,7,4,5, 10,11,8,9}}, 
       ws[Sym]={1};
#else
#define Sym 0  
  int  is[1][NN], ws[1];
#endif
  int initvars()
  { int i,j; 
    printf("M-L1-bounds:"); 
    for(i=0;i<NN/3;i++){iw[i][0]=1+i;iw[i][1]=1+i+NN/3;
      printf(" [%i,%i]",iw[i][0],iw[i][1]);}printf("\n");
    printf("L1-M-bounds:"); 
    for(i=0;i<NN/3;i++){iw[i+NN/3][0]=1+i+NN/3;iw[i+NN/3][1]=1+(i+1)%(NN/3);
      printf(" [%i,%i]",iw[i+NN/3][0],iw[i+NN/3][1]);}printf("\n");
    printf("M-L2-bounds:"); 
    for(i=0;i<NN/3;i++){iw[i+2*NN/3][0]=1+i;iw[i+2*NN/3][1]=1+i+2*NN/3;
      printf(" [%i,%i]",iw[i+2*NN/3][0],iw[i+2*NN/3][1]);}printf("\n");
    printf("L2-M-bounds:"); 
    for(i=0;i<NN/3;i++){iw[i+NN][0]=1+i+2*NN/3;iw[i+NN][1]=1+(i+1)%(NN/3);
      printf(" [%i,%i]",iw[i+NN][0],iw[i+NN][1]);}printf("\n");
    for(i=0;i< Nw;i++)wj[i]= 0.0;
    for(i=0;i< Nw;i++)wt[i]=(i<Nw/2)?((i<Nw/4)?1.0:-1.0):0.8;
    for(i=0;i< NN;i++)wu[i]=(i<NN/3)?8.0:0.0;
    for(i=0;i< NN;i++)we[i]=(i<NN/3)?0.0:((i<2*NN/3)?4:3);
    for(i=0;i<Sym;i++)ws[i]= 1.0;
    return 0;
  }
/* ================== Cu-Gitter nach Betts =========================== */
#elif defined(N0) && defined(N1) && defined(N2) && (M_tU>0) && defined(TwoOrb)
/* => Betts-Notation example: 14h4 => N=14,N1=1,N2=4 => 1 helix, dy=4 */
#ifndef Sym
#define Sym 0
#endif      /* mit option -DSym=xxx compilieren */
#define NN 2*N0
#define Nw 3*NN
#define Ne NN
#define Nv N0
  int  io=1, nu=N0/2, nd=N0/2+N0%2, iw[Nw][2];
  cplx wj[Nw], wt[Nw], wu[NN], we[NN];
  int iw2[Nv][2];
  zahl wv[2 ]={ 7.0, 8.0};
  int  is[(Sym)?Sym:1][NN], ws[(Sym)?Sym:1];

  /*  i=site 0..N0, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  int site_move(int i,int d,int s){ 
    if(i<0 || i>=N0)return -1;while(s<0)s+=N0/N1;
    if(d==0)return (i+s)%(N0/N1)+(i/(N0/N1))*(N0/N1);   /* x-direction */
    if(d==1)return (i+s+((i/(N0/N1)+s)/N1)*(N2-N1+N0/N1))%(N0/N1)+
                   ((i/(N0/N1)+s)%N1)*(N0/N1);          /* y-direction */
    return -1;}

  int initvars()
  { int i,j; 
    printf("x-bounds:"); /* [i,i+(0,1)] evl. array von fkt. nachbar(i) */
    for(i=0;i<N0;i++){
      iw[i     ][0]=i+1;   iw[i     ][1]=site_move(i,0,1)+1;
      printf(" [%i,%i]",   iw[i     ][0],iw[i     ][1]);
      iw[i+2*N0][0]=i+1;   iw[i+2*N0][1]=site_move(i,0,1)+1+N0;
      printf(" [%i,%i]",   iw[i+2*N0][0],iw[i+2*N0][1]);
      iw[i+3*N0][0]=i+1+N0;iw[i+3*N0][1]=site_move(i,0,1)+1;
      printf(" [%i,%i]",   iw[i+3*N0][0],iw[i+3*N0][1]);
    }printf("\n");
    printf("y-bounds:"); /* [i,i+(1,0)] */
    for(i=0;i<N0;i++){
      iw[i+  N0][0]=i+1;   iw[i+  N0][1]=site_move(i,1,1)+1;
      printf(" [%i,%i]",   iw[i+  N0][0],iw[i+  N0][1]);
      iw[i+4*N0][0]=i+1;   iw[i+4*N0][1]=site_move(i,1,1)+1+N0;
      printf(" [%i,%i]",   iw[i+4*N0][0],iw[i+4*N0][1]);
      iw[i+5*N0][0]=i+1+N0;iw[i+5*N0][1]=site_move(i,1,1)+1;
      printf(" [%i,%i]",   iw[i+5*N0][0],iw[i+5*N0][1]);
    }printf("\n");
    printf("JH-bounds:");
    for(i=0;i<N0;i++){
      iw2[i][0]=i+1;        iw2[i][1]=i+1+N0;
      printf(" [%i,%i]",   iw2[i][0],iv[i][1]);
    }printf("\n");
    for(i=0;i< Nw;i++)wj[i]=(i<Nw/2)?1.0:0.0;
    for(i=0;i< Nw;i++)wt[i]=(i<2*N0)?0.2:1.0;
    for(i=0;i< NN;i++)wu[i]= 8.0;
    for(i=0;i< NN;i++)we[i]=(i<N0) ? 0.0:0.5;
    for(i=0;i<Sym;i++)ws[i]= 1;
    return 0;
  }
/* #endif defined(NN) && defined(N1) && defined(N2) */
/* ================== 2D-Gitter nach Betts =========================== */
#elif defined(NN) && defined(N1) && defined(N2) && (M_tJ+M_JJ+M_tU>0)
/* => Betts-Notation example: 14h4 => N=14,N1=1,N2=4 => 1 helix, dy=4 */
#ifndef Sym
#define Sym 0
#endif      /* mit option -DSym=xxx compilieren */
#define Nw 4*NN
#define Ne NN
  int  io=1, nu=NN/2, nd=NN/2+NN%2, iw[Nw][2];
  cplx wj[Nw], wt[Nw], wu[NN], we[NN];
  int  is[(Sym)?Sym:1][NN], ws[(Sym)?Sym:1];

  /*  i=site 0..NN, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  int site_move(int i,int d,int s){ 
    if(i<0 || i>=NN)return -1;while(s<0)s+=NN/N1;
    if(d==0)return (i+s)%(NN/N1)+(i/(NN/N1))*(NN/N1);   /* x-direction */
    if(d==1)return (i+s+((i/(NN/N1)+s)/N1)*(N2-N1+NN/N1))%(NN/N1)+
                   ((i/(NN/N1)+s)%N1)*(NN/N1);          /* y-direction */
    return -1;}

  int initvars()
  { int i,j; 
    printf("x-bounds:"); /* [i,i+(0,1)] evl. array von fkt. nachbar(i) */
    for(i=0;i<NN;i++){iw[i][0]=i+1;iw[i][1]=site_move(i,0,1)+1;
      printf(" [%i,%i]",iw[i][0],iw[i][1]);}printf("\n");
    printf("y-bounds:"); /* [i,i+(1,0)] */
    for(i=0;i<NN;i++){iw[i+NN][0]=i+1;iw[i+NN][1]=site_move(i,1,1)+1;
      printf(" [%i,%i]",iw[i+NN][0],iw[i+NN][1]);}printf("\n");
    printf("x+y-bounds:"); /* [i,i+(1,1)] */
    for(i=0;i<NN;i++){
      iw[i+2*NN][0]=i+1;iw[i+2*NN][1]=site_move(site_move(i,1,1),0,1)+1;
      printf(" [%i,%i]",iw[i+2*NN][0],iw[i+2*NN][1]);}printf("\n");
       printf("x-y-bounds:"); /* [i,i+(1,1)] */
    for(i=0;i<NN;i++){
      iw[i+3*NN][0]=i+1;iw[i+3*NN][1]=site_move(site_move(i,1,-1),0,1)+1;
      printf(" [%i,%i]",iw[i+3*NN][0],iw[i+3*NN][1]);}printf("\n");
    for(i=0;i< Nw;i++)wj[i]=(i<Nw/2)?1.0:0.0;
    for(i=0;i< Nw;i++)wt[i]=(i<Nw/2)?1.0:0.0;
    for(i=0;i< NN;i++)wu[i]= 8.0;
    for(i=0;i< NN;i++)we[i]= 0.0;
    for(i=0;i<Sym;i++)ws[i]= 1;
    printf("Gitter:\n");for(i=0;i<NN/N1;i++){ for(j=0;j<NN/N1;j++)
     printf(" %2d",site_move(site_move(0,1,i),0,j)+1);printf("\n");}
    return 0;
  }
/*
#undef N1
#undef N2  
*/
/* #endif defined(NN) && defined(N1) && defined(N2) */
#elif defined(Kette) /* ================================================= */  
#define Nw NN
  int  io=1,nu=NN/2,nd=NN/2+NN%2;
  int  iw[Nw][2];
  cplx wt[Nw],wj[Nw],wu[NN],we[NN];
#ifndef Sym       /* mit option -DSym=xxx compilieren */
#define Sym 0
#endif
  int  is[(Sym)?Sym:1][NN], ws[(Sym)?Sym:1];
  int initvars()
  { int i,j; printf("bounds:");
    for(i=0;i<NN;i++){iw[i][0]=i+1;iw[i][1]=(i+1<NN)?i+2:1;
                     printf(" [%i,%i]",iw[i][0],iw[i][1]);}printf("\n");
    for(i=0;i<NN;i++)wt[i]=-1.0;
    for(i=0;i<NN;i++)wj[i]= 1.0;
    for(i=0;i<NN;i++)wu[i]= 8.0;
    for(i=0;i<NN;i++)we[i]= 0.0;
    for(i=0;i<Sym;i++)ws[i]= 1.0;
    return 0;
  }
#elif NN == 8 && !defined(Layer)     /* Betts: 8d2  N1=2 N2=2 */
                  /*           4 5 6 3 4 5 */
#define Nw 32     /*   7 8     1 2 7 8 1 2 */
                  /* 3 4 5 6   6 3 4 5 6 3 */
                  /*   1 2     7 8 1 2 7 8 */
                  /*           4 5 6 3 4 5 */
  int io=1,nu=4,nd=4;
#ifndef Sym  
#define Sym 3   /* Anz. lin-unanh. vertausch. Sym-Op. S mit S^2=1 */
#endif
  int is[Sym][NN]={ 1, 0, 5, 4, 3, 2, 7, 6, 
  /* 0..NN-1 */     3, 4, 7, 0, 1, 6, 5, 2,
  /* 0..NN-1 */     6, 7, 4, 5, 2, 3, 0, 1};
  int ws[Sym]={ 1, 1, 1};    /* Subraum = SymmetryQuantumNumbers */   
  int iw[Nw][2]={ 1,2, 1,4, 1,6, 1,8, 2,3, 2,5, 2,7, 3,4,  /* nn */
                  3,6, 3,8, 4,5, 4,7, 5,6, 5,8, 6,7, 7,8,  /* nn */
                  1,3, 1,5, 2,4, 2,6, 3,7, 4,8, 5,7, 6,8,  /* nnn-diago */
                  1,3, 1,5, 2,4, 2,6, 3,7, 4,8, 5,7, 6,8}; /* nnn 2fach */
  cplx wt[Nw],wj[Nw],wu[NN],we[NN];
  int initvars(){ int i;
    for(i=0;i<Nw;i++)wt[i]=((i<Nw/2)?-1.0: 0.0);
    for(i=0;i<Nw;i++)wj[i]=((i<Nw/2)? 1.0: 0.0);
    for(i=0;i<NN;i++)wu[i]=8.0;
    for(i=0;i<NN;i++)we[i]=0.0;
    return 0;
  }
#elif NN == 10    /* 3^2+1^2=10 */
                  /*               2  3  8  9 10  7 */
                  /*    1  2  3    5  4  1  2  3  8 */
                  /* 7  6  5  4   10  7  6  5  4  1 */
                  /* 8  9 10       3  8  9 10  7  6 */
                  /*               4  1  2  3  8  9 */
#define Nw 30
#define Ne 10
  int io=1,nu=3,nd=2;
  int iw[Nw][2]={ 1, 2,  2, 3,  3, 8,  8, 9,  9,10
                , 7,10,  6, 7,  5, 6,  4, 5,  1, 4 /* nnx  */
                , 1, 6,  6, 9,  2, 9,  2, 5,  5,10
                , 3,10,  3, 4,  4, 7,  7, 8,  1, 8 /* nny  */
                , 1, 5,  5, 7,  7, 9,  3, 9,  1, 3 /* nnxy */
                , 1, 9,  5, 9,  3, 5,  3, 7,  1, 7 /* nnyx */ };
#ifndef Sym  
#define Sym 3   /* Anz. lin-unanh. vertausch. Sym-Op. S mit S^2=1 */
#endif
  int is[Sym][NN],ws[Sym];    /* Subraum = SymmetryQuantumNumbers */   
  cplx wt[Nw],wj[Nw];
  zahl wu[NN],we[NN];
  int initvars(){  
     int i;
     for(i=0;i<Nw;i++){wj[i]=(i<2*NN)? 1.0:0.1;}
     for(i=0;i<Nw;i++){wt[i]=(i<2*NN)?-1.0:0.1;}
     for(i=0;i<NN;i++){wu[i]=(i<2*NN)?10.0:0.0;}
     for(i=0;i<NN;i++){we[i]=(i<2*NN)? 4.0:0.0;}
     return 0;}
/* ------------------------- 16 Platz --------------------------------- */
#elif NN == 16        /* N1=4 N2=0   */
                      /*  1  2  3  4 */  
#define Nw 64         /*  8  7  6  5 */
                      /*  9 10 11 12 */
                      /* 16 15 14 13 */
  int iw[Nw][2]={ 1, 2,  2, 3,  3, 4,  1, 4,   7, 8,  6, 7,  5, 6,  5, 8,
                  9,10, 10,11, 11,12,  9,12,  15,16, 14,15, 13,14, 13,16,
                  1, 8,  8, 9,  9,16,  1,16,   2, 7,  7,10, 10,15,  2,15,
                  3, 6,  6,11, 11,14,  3,14,   4, 5,  5,12, 12,13,  4,13,
                  1, 7,  7,11, 11,13,  1,13,   2, 6,  6,12, 12,16,  2,16,
                  3, 5,  5, 9,  9,15,  3,15,   4, 8,  8,10, 10,14,  4,14,
                  1, 5,  5,11, 11,15,  1,15,   2, 8,  8,12, 12,14,  2,14,
                  3, 7,  7, 9,  9,13,  3,13,   4, 6,  6,10, 10,16,  4,16};
  int io=1,nu=8,nd=8;
#ifndef Sym  
#define Sym 4   /* Anz. lin-unanh. vertausch. Sym-Op. S mit S^2=1 */
#endif
  int is[Sym][NN]={ 2, 3, 0, 1, 6, 7, 4, 5,10,11, 8, 9,14,15,12,13, /* 2x */
  /* 0..NN-1 */     8, 9,10,11,12,13,14,15, 0, 1, 2, 3, 4, 5, 6, 7, /* 2y */
                    1, 0, 3, 2, 5, 4, 7, 6, 9, 8,11,10,13,12,15,14, 
                    7, 6, 5, 4, 3, 2, 1, 0,15,14,13,12,11,10, 9, 8};
  int  ws[4];
  cplx wt[Nw],wj[Nw],wu[NN],we[NN];
  int initvars()
  { int i;
    for(i=0;i<Nw;i++)wt[i]=((i<Nw/2)?-1.0: 0.0);
    for(i=0;i<Nw;i++)wj[i]=((i<Nw/2)? 1.0: 0.1);
    for(i=0;i<NN;i++)wu[i]=8.0;
    for(i=0;i<NN;i++)we[i]=0.0;
#ifdef SBase
    x_p=0;
#endif         
    return 0;
  }
#elif M_tJ>0  && NN == 4
/* ---------------------------------------------------------------------- */  
                         /*  1 - 2  */
#define Nw 6             /*  | X |  */
  int  io=1,nu=2,nd=2;   /*  4 - 3  */
  int  iw[Nw][2]={{1,2},{2,3},{3,4},{1,4},{1,3},{2,4}};
  cplx wt[Nw]={-1.0,-1.0,-1.0,-1.0, 0.0, 0.0};
  cplx wj[Nw]={ 1.0, 1.0, 1.0, 1.0, 0.0, 0.0};
#ifndef Sym  
#define Sym 2   /* Anz. lin-unanh. vertausch. Sym-Op. S mit S^2=1 */
#endif
  int is[Sym][NN];/*={ 1, 0, 3, 2,   3, 2, 1, 0}; /* x, y */
  int ws[Sym]; /* Subraum = SymmetryQuantumNumbers option: -DSBase=1 */   
  int initvars(){ int i;for(i=0;i<Sym;i++)ws[i]=1;return 0;}
/* ======================== Heisenberg ========================= */
#elif M_JJ>0 && defined(Layer)   /* lieb-mattis-bilayer ohne frustration! */
#if NN%4 != 0
#error NN muss durch 4 teilbar sein!
#endif
#define Nw (2*(NN/4)*(NN/4)+2*(NN/4))
  int io=1,nu=NN/2,nd=NN/2;
  int iw[Nw][2];
  cplx wj[Nw];
#ifndef Sym
#define Sym 0
#endif      /* mit option -DSym=xxx compilieren */
   int is[(Sym)?Sym:1][NN];
   int ws[(Sym)?Sym:1];
  int initvars()
  { int i,j=(NN/4);
    printf("A1-B1:");for(i=0;i<j*j;i++){
     printf(" [%d,%d]",i/j+1,j+i%j+1);                 /* A1-B1 */
     iw[i][0]=i/j+1;iw[i][1]=j+i%j+1;}                 /* A1-B1 */
    printf("\n"); 
    printf("A2-B2:");for(i=0;i<j*j;i++){
     printf(" [%d,%d]",2*j+i/j+1,2*j+j+i%j+1);         /* A2-B2 */
     iw[j*j+i][0]=2*j+i/j+1;iw[j*j+i][1]=2*j+j+i%j+1;} /* A2-B2 */
    printf("\n"); 
    printf("1-2:");for(i=0;i<2*j;i++){
     printf(" [%d,%d]",i+1,2*j+i+1);                   /* 1-2 */
     iw[2*j*j+i][0]=i+1;iw[2*j*j+i][1]=2*j+i+1;}       /* 1-2 */
    printf("\n"); 
    for(i=0;i< Nw;i++)wj[i]=(i<2*(NN/4)*(NN/4))?1.0/(NN/4):1.0;
    for(i=0;i<Sym;i++)ws[i]= 1.0;
    return 0;
  }
#elif M_tU         /* Hubbard */
#if NN == 3  /* 2u1d=9 2u0d=3 3u1d=3 1u1d=9 */
#define Nw 3
#define Ne 3
  int io=1,nu=1,nd=1;
  int iw[Nw][2]={{1,2},{2,3},{1,3}};
  cplx wt[Nw]={Z( 0.0),Z( 1.0),Z( 1.0)};
  zahl wu[NN]={Z( 8.0),Z( 8.0),Z( 0.0)};
  zahl we[Ne]={Z( 0.0),Z( 0.0),Z( 3.0)};
  /* Symmetrie 3 fuer Bloch-(cos(k)/sin(-k))-ansatz */
  #define Sym 1
   int is[Sym][NN]={ 1, 0, 2}; /* Permutationsoperator */
  /* cplx ik[3]={ 3.0, 4.0, 0.0}; /* k=0 */
  /* cplx ik[3]={ 1.0, 1.0, 1.0}; /* k=0 */
  /* cplx ik[3]={ 2.0,-1.0,-1.0}; /* k=2*pi/3 cos */
  /* cplx ik[3]={ 0.0, 1.0,-1.0}; /* k=2*pi/3 sin */
  /* Blochfaktoren, Berechnung ungenau: sin(2*Pi/3)!=sin(4*Pi/3) */
  int initvars(){ return 0;}
#elif NN == 4  /* A - B - A - B -  */
#define Nw 4
#define Ne 4
  int io=1,nu=1,nd=1;
  int iw[Nw][2]={{1,2},{2,3},{3,4},{1,4}};
  cplx wt[Nw]={C(12.0,1.),C(23.0,1.),C(34.0,1.),C(14.0,1.)};
  zahl wu[NN]={Z(100.0),Z(200.0),Z(400.0),Z(800.0)};
  zahl we[NN]={Z( 1.0),Z( 2.0),Z( 4.0),Z( 8.0)};
/* #define Sym 2
/*   int is[Sym][NN]={ 0, 3, 2, 1,  /* 1 <-> 3 */
/*                    1, 2, 3, 0}; /* Tx */
  int initvars(){ return 0;}
#endif
/* -------------------------------------------------------------------- */
#if bipartit  /*  A - B - A - B - A  - B - ...  */
#define NN 8   /*  must be ewen and greater 2    */
#define Nw ((NN/2)*(NN/2)/* +NN/2*(NN/2-1) */)
/* #define Ne NN */
  int io=1,nu=NN/2,nd=NN/2;
  int iw[Nw][2];
  cplx wt[Nw];
  zahl wu[NN];
/*  zahl we[NN]; */
 #define Sym 2                   /* Anzahl der ...      */
  int is[Sym][NN];                /* SymmetrieOperatoren */
  int ik[Sym];                   /* Quantenzahlen */
  int initvars()
  {  int i1,i2,i3;
     i2=1;i3=2;
     for(i1=0;i1<(NN/2)*(NN/2);i1++)
     {  iw[i1][0]=i2;iw[i1][1]=i3;
        i3+=2;if(i3>NN){i2++;i3=i2+1;}
     }
/*     i2=1;i3=3;
     for(i1=0;i1<(NN/2)*(NN/2-1);i1+=2)
     {  iw[i1+(NN/2)*(NN/2)  ][0]=i2;  iw[i1+(NN/2)*(NN/2)  ][1]=i3;
        iw[i1+(NN/2)*(NN/2)+1][0]=i2+1;iw[i1+(NN/2)*(NN/2)+1][1]=i3+1;
        i3+=2;if(i3>NN){i2+=2;i3=i2+2;}
     }
*/   for(i1=0;i1<NN/2*NN/2;  i1++)wt[i1]=Z(1.0/NN); /* E_t=intensiv */
/*   for(i1=0;i1<NN/2*(NN/2-1);i1++)wt[i1+NN/2*NN/2]=Z( 0.0/NN); /* E_t=intensiv */
     for(i1=0;i1<NN;i1++)wu[i1]=Z( 0.1);
/*   for(i1=0;i1<NN;i1++)we[i1]=Z( 0.0); */
/*   for(i1=0;i1<NN;i1++)is[0][i1]=i1;is[0][0]=min(2,NN-1);
     is[0][min(2,NN-1)]=0;                                       /* 1-3 */
/*   for(i1=0;i1<NN;i1++)is[1][i1]=(i1+1)%NN;                     /* Tx  */
     for(i1=0;i1<NN;i1++)is[0][i1]=1-i1%2+2*(i1/2);              /* 1-2 */
     for(i1=0;i1<4*(NN/4);i1++)is[1][i1]=i1%2+2-2*((i1%4)/2)+4*(i1/4);/* 1-3 */
     for(i1=0;i1<Sym;i1++)ik[i1]=-1;
     return 0;
  }
#endif /* bipartit */
/* --------------------------------------------------------------------- */
#if star  /*  A - 1 - 2 - 3 - 4  - 5 - ...  */
#define NN 5 /*  must be ewen and greater 2    */
#define Nw (NN-1+NN-1)
/* #define Ne NN */
  int io=1,nu=NN/2,nd=NN/2+NN%2;
  int iw[Nw][2];
  cplx wt[Nw];
  zahl wu[NN];
/*  zahl we[NN]; */
 #define Sym 2                   /* Anzahl der ...      */
  int is[Sym][NN];                /* SymmetrieOperatoren */
  int ik[Sym];                   /* Quantenzahlen */
  int initvars()
  {  int i1,i2,i3;
     i2=1;i3=2;
     for(i1=0;i1<NN-1;i1++)
      { iw[i1][0]=1;iw[i1][1]=i1+2; }
     for(i1=0;i1<NN-1;i1++)
      { iw[NN-1+i1][0]=((i1>0)?i1+1:NN);iw[NN-1+i1][1]=i1+2; }
     for(i1=0;i1<Nw;i1++)wt[i1]=Z((i1<NN-1)?1.0:0.0); /* E_t=intensiv */
     for(i1=0;i1<NN;i1++)wu[i1]=Z( 0.1);
/*     for(i1=0;i1<NN;i1++)we[i1]=Z( 0.0); */
     for(i1=0;i1<NN;i1++)is[0][i1]=i1;is[0][1]=2;is[0][2]=1; /* 2-3   */
     for(i1=1;i1<NN;i1++)is[1][i1]=i1;is[1][1]=2;is[1][3]=1;is[1][2]=3; /* 2-4   */
     for(i1=0;i1<Sym;i1++)ik[i1]=-1;
     return 0;
  }
#endif /* star */
/* --------------------------------------------------------------------- */
#if KCuF /* _1_Cu_orbital  */
/* F2,F1,K1,K2,Cu21,Cu11 */
#define NN   6
#define Nw  7
#define Nv  0
#define Ne  7
  int io=1,nu=3,nd=3;
  int iw[Nw][2]={ 1, 2, 1, 3, 2, 4       /* F2F1   F2K1   F1K2          */
                , 1, 5, 2, 6, 4, 5, 3, 6 /* F2Cu21 F1Cu11 K2Cu21 K1Cu11 */ };
  cplx wt[Nw]={-0.059, 1.50, /*-*/1.50 /* hoppings um Cu1 & K1 *(-1) (sym) */
                ,/*-*/1.40,  1.40, 0.033, 0.033 /* (6+0)er */ };
  zahl wv[2 ]={ 7.0, 8.0};
  zahl we[NN]={ 4.0, 4.0,-4.0,-4.0, 0.0, 0.0 };
  zahl wu[NN]={ 0.0, 0.0, 0.0, 0.0, 8.0, 8.0 };
#define Sym 1               /* Anzahl der  SymmetrieOperatoren */
  int is[Sym][NN]={1,0,3,2,5,4};
  int initvars(){ return 0;}
#elif KCuF_5_Cu_orbitals /* */
/* NN Nu Nd    N1     N2 Nw Nv */ /* NN Nu Nd    N1     N2 Nw Nv */
/* 14  4  2  91091 16384 23 20 */ /* 14  3  3 132496 16384 23 20 */
/* 12  4  2  32670  4096 19 12 */ /* 12  3  3  48400  4096 19 12 */
/* 10  4  2   9450  1024 15  6 */ /* 10  3  3  14400  1024 15  6 */
/*  8  4  2   1960   256 11  2 */ /*  8  3  3   3136   256 11  2 */
/*  8  2  0     28   256 11  2 */ /*  8  1  1     64   256 11  2 */
/* F2,F1,K1,K2,Cu21,Cu11,Cu22,Cu12,Cu23,Cu13,Cu24,Cu14,Cu25,Cu15 */
#define NN 14
#define Nw 23
#define Nv 20
#define Ne 14
  int io=1,nu=3,nd=3;
  int iw[Nw][2]={ 1, 2, 1, 3, 2, 4       /* F2F1   F2K1   F1K2          */
                , 1, 5, 2, 6, 4, 5, 3, 6 /* F2Cu21 F1Cu11 K2Cu21 K1Cu11 */
                , 1, 7, 2, 8, 4, 7, 3, 8 /* F2Cu22 F1Cu12 K2Cu22 K1Cu12 */
                , 1, 9, 2,10, 4, 9, 3,10 /* F2Cu23 F1Cu13 K2Cu23 K1Cu13 */
                , 1,11, 2,12, 4,11, 3,12 /* F2Cu24 F1Cu14 K2Cu24 K1Cu14 */
                , 1,13, 2,14, 4,13, 3,14 /* F2Cu25 F1Cu15 K2Cu25 K1Cu15 */
                };
  cplx wt[Nw]={  -0.03, -1.50,  1.50     /* vorzeichen korrigiert */
                , 1.40, -1.40,-0.033,-0.033 /* (6+0)er */
                ,-0.80,  0.80, 0.022, 0.022 /* (6+2)er */
                , 0.00,  0.00,  0.25,  0.25 /* (6+4)er */
                , 0.00,  0.00,  0.28,  0.28 /* (6+6)er */
                , 0.00,  0.00,  0.25,  0.25 /* (6+8)er */
                };
  int iv[Nv][2]={ 5, 7, 6, 8
                , 5, 9, 6,10, 7, 9, 8,10                        /* 10er */
                , 5,11, 6,12, 7,11, 8,12,9,11,10,12             /* 12er */
                , 5,13, 6,14, 7,13, 8,14,9,13,10,14,11,13,12,14 /* 14er */
                };
  zahl wv[2 ]={ 7.0, 8.0};
  zahl we[NN]={ 4.0, 4.0,-4.0,-4.0, 0.0, 0.0, 0.5, 0.5
              , 1.4, 1.4, 1.5, 1.5, 1.6, 1.6  };
  zahl wu[NN]={ 0.0, 0.0, 0.0, 0.0, 8.0, 8.0, 8.0, 8.0
              , 8.0, 8.0, 8.0, 8.0, 8.0, 8.0  };
  int initvars(){ return 0;}
#endif

#if LaBaCuO /* _with_2_La_&_1_Cu_Orbitals */
/* NN Nu Nd    N1     N2 Nw Nv */ /* NN Nu Nd    N1     N2 Nw Nv */
/* 10  4  2   9450  1024 15  6 */ /* 10  3  3  14400  1024 15  6 */
/* LaL1 LaR1 O1L O1R O2L O2R Cu1 Cu2 LaL2 LaR2 */
#define NN 10
#define Nw 14
#define Nv 0 
#define Ne 10
  int io=1,nu=5,nd=5;
  int iw[Nw][2]={ 3, 5, 4, 6
                , 1, 5, 2, 6, 1, 3, 2, 4
                , 3, 7, 4, 7, 5, 8, 6, 8
                , 5, 9, 6,10, 3, 9, 4,10
                };
  cplx wt[Nw]={ 0.05, 0.05
                , 1.20,-1.20, 1.20,-1.20
                ,-1.30, 1.30,-1.30, 1.30
                , 0.70, 0.70,-0.70,-0.70
                };
  zahl wv[2 ]={ 5.0, 8.0};
  zahl we[NN]={-4.0,-4.0, 4.0, 4.0, 4.0, 4.0
                , 0.0, 0.0,-3.5,-3.5 };
  zahl wu[NN]={ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
                , 8.0, 8.0, 0.0, 0.0 };
  int initvars(){ return 0;}
#endif
#if LaBaCuO_with_2_La_&_2_Cu_Orbitals
/* NN Nu Nd    N1     N2 Nw Nv */ /* NN Nu Nd    N1     N2 Nw Nv */
/* 10  4  2   9450  1024 15  6 */ /* 10  3  3  14400  1024 15  6 */
/* LaL1 LaR1 O1L O1R O2L O2R Cu1 Cu2 Cu12 Cu22 LaL2 LaR2 */
#define NN 12
#define Nw 18
#define Nv 2
#define Ne 12
  int io=1,nu=5,nd=5;
  int iw[Nw][2]={ 3, 5, 4, 6
                , 1, 5, 2, 6, 1, 3, 2, 4
                , 3, 7, 4, 7, 5, 8, 6, 8
                , 3, 9, 4, 9, 5,10, 6,10
                , 5,11, 6,12, 3,11, 4,12
                };
  cplx wt[Nw]={ 0.05, 0.05
                , 1.20,-1.20, 1.20,-1.20
                ,-1.30, 1.30,-1.30, 1.30
                ,-0.80,-0.80, 0.80, 0.80 /* ??? */
                , 0.70, 0.70,-0.70,-0.70
                };
  int iv[Nv][2]={ 7, 9, 8,10
                };
  zahl wv[2 ]={ 5.0, 8.0};
  zahl we[NN]={-4.0,-4.0, 4.0, 4.0, 4.0, 4.0
                , 0.0, 0.0, 0.5, 0.5,-3.5,-3.5 };
  zahl wu[NN]={ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
                , 8.0, 8.0, 8.0, 8.0, 0.0, 0.0 };
  int initvars(){ return 0;}
#endif
#if LaBaCuO_only_1_La_&_2_Cu_Orbitals
/* NN Nu Nd    N1     N2 Nw Nv */ /* NN Nu Nd    N1     N2 Nw Nv */
/* 10  4  2   9450  1024 15  6 */ /* 10  3  3  14400  1024 15  6 */
/* LaL LaR O1L O1R O2L O2R Cu1 Cu2 Cu12 Cu22 */
#define NN 10
#define Nw 14
#define Nv 2
#define Ne 10
  int io=1,nu=1,nd=1;
  int iw[Nw][2]={ 3, 5, 4, 6
                , 1, 5, 2, 6, 1, 3, 2, 4
                , 3, 7, 4, 7, 5, 8, 6, 8
                , 3, 9, 4, 9, 5,10, 6,10
                };
  cplx wt[Nw]={ 0.05, 0.05
                , 1.20,-1.20, 1.20,-1.20
                ,-1.30, 1.30,-1.30, 1.30
                ,-0.80,-0.80, 0.80, 0.80  /* ??? */
                };
  int iv[Nv][2]={ 7, 9, 8,10};
  zahl wv[2 ]={ 5.0, 8.0};
  zahl we[NN]={ 4.0, 4.0, 4.0, 4.0, 4.0, 4.0, 0.0, 0.0, 0.5, 0.5 };
  zahl wu[NN]={ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8.0, 8.0, 8.0, 8.0 };
  int initvars(){ return 0;}
#endif
#if NN>16
#error to many sizes (NN>16)
#endif
#endif /* elif M_tU */
#if !defined(NN)
#include "spins.h"
#endif  
